dofile("Regenerators.rte/HWall.lua");
dofile("Regenerators.rte/VWall.lua");

function regeneratorgetPixel(x,y,width)
	return (y * width) + x;
end

function regeneratordrawmodule(self,diffy)
	--this is where the magic happens. brilliant function design is mostly TLB and Kyred, I can't claim much.
	local width,height,pixels = nil,nil,nil;
	if self.PresetName == "Regenerator H" then
		pixels = regeneratorhwall;
		width, height = 96,24;
	else
		pixels = regeneratorvwall;
		width, height = 24,96;
	end

	local deltay,deltax = diffy,0;
	--these locals above are set to various attributes from the lua files spit out by bmptoarray. the bracketed numbers refer to cells within the arrays defined in those files.
	local firstrun = true;
		
	if deltay < height then
		for i = (deltay * width), #pixels - 1, 1 do
			deltax = i % width;
			if deltax == 0 and firstrun == false then
				deltay = deltay + 1;
				break;
			end
			--basically this business here just increments over each x pixel while storing the height
			local ppos = Vector(((self.Pos.X - math.floor(width / 2)) + deltax) % SceneMan.SceneWidth,((self.Pos.Y + math.floor(height / 2)) - (deltay + 1)) % SceneMan.SceneHeight);
			local pixel = pixels[regeneratorgetPixel(deltax + 1,deltay,width)];
			local color = tostring(pixel[1]..","..pixel[2]..","..pixel[3]);
			--color is a vector listed inside the vector that's inside the vector that's inside the vector of modules.
			--you could also call color constructorpieces[cellnumber][3][1]
			if color ~= "255,0,255" then
				--color 255,0,255 means an air pixel, meaning no construction is required. this checks that that's NOT true, allowing it to be built.
				local piece = CreateMOPixel(color,"Regenerators.rte");
				piece.Pos = ppos;
				MovableMan:AddParticle(piece);
				piece.ToSettle = true;
				local glow = CreateMOPixel("Pixel Creation Glow","Regenerators.rte");
				glow.Pos = ppos;
				MovableMan:AddParticle(glow);
			end
			if i == #pixels - 1 then
				deltay = deltay + 1;
			end
			firstrun = false;
		end
	else
		return false;
	end
	
	return true;
end

function Create(self)
	self.refreshtimer = Timer();
	self.todraw = true;
	self.diffy = 0;
end

function Update(self)
	self.ToSettle = false;
	self.ToDelete = false;
	self.Age = 1;
	self.Vel = Vector(0,0);
	self.PinStrength = 9999999;
	
	if self.diffy ~= 0 or self.todraw == true then
		regeneratordrawmodule(self,self.diffy)
		self.diffy = self.diffy + 1;
		self.todraw = false;
	end
	
	if self.refreshtimer:IsPastSimMS(5000) == true then
		self.refreshtimer:Reset();
		self.diffy = 0;
		self.todraw = true;
	end
end